package server.database.schema.maintenance;

import server.database.schema.SchemaColumn;
import exception.DatabaseException;

/**
 * Tabellen-Schema fuer den unflexiblen statischen SignatureCensor.
 * 
 * Achtung: Fuer eine korrekte Funktionsweise des SignatureCensors muss zusaetzlich zur 
 * Generierung des Schemas auch die sql-Datei 'staticSignatureCensorExperimentCreate.sql', 
 * die u.a. die Trigger fuer den SignatureCensor enthaelt, in der Datenbank ausgefuehrt 
 * werden.
 */
public class SignaturesUnflexibleSignaturesKrankheitSchema extends SignaturesUnflexibleSignaturesSchema {
	
	public final static SchemaColumn SYMPTOM = new SchemaColumn("SYMPTOM", "VARCHAR2(400 BYTE)", true, true);
	public final static SchemaColumn DIAGNOSIS = new SchemaColumn("DIAGNOSIS", "VARCHAR2(400 BYTE)", true, true);
	public final static SchemaColumn PATIENT = new SchemaColumn("PATIENT", "VARCHAR2(400 BYTE)", true, true);
	
	public SignaturesUnflexibleSignaturesKrankheitSchema() throws DatabaseException {
		super(TABLE_PREFIX + "SIG_KRANKHEIT", SIG_ID, USER_ID, SYMPTOM, DIAGNOSIS, PATIENT, FLAG_OLD, FLAG_IMPL);
	}
}
